/*
btdlets.c Version 0.2.0  Btree counts deleted index
records in database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* returns total blocks and total count */
/* in database */

#include <bthash.h>

void btdlets(bthdr,blocks,count,
   leaf,nonleaf,active,deletes,
   indxrcd,leafrcd)
btreefmt *bthdr;
int *blocks;
int *count;
int *leaf;
int *nonleaf;
int *active;
int *deletes;
int *indxrcd;
int *leafrcd;
   {
   int eofsw,rdlen;
   int rcdnum;
   blkfmt *blk;
   off_t loc;
   unsigned char *p;
   unsigned char *rcdptr;
   unsigned char buf[65536 + 16];
   bthdr->reason = 0;
   loc = lseek(bthdr->hndl,ROOT,SEEK_SET);
   if (loc != ROOT)
      {
      perror("btdlets: lseek err");
      bthdr->reason = SYS_ERR + errno;
      return;
      } /* if lseek err */
   *blocks = *count = eofsw = 0;
   *leaf = *nonleaf = *deletes = *active = 0;
   *indxrcd = *leafrcd = 0;
   blk = (blkfmt *) buf;
   while (!eofsw)
      {
      rdlen = read(bthdr->hndl,buf,bthdr->blksz);
      if (rdlen < 0)
	 {
         perror("btdlets: read error");
         bthdr->reason = SYS_ERR + errno;
         return;
	 } /* read err */
      if (rdlen == bthdr->blksz)
	 {
         *count += blk->count;
         (*blocks)++;
	 rcdnum = 0;
	 if (blk->right)
	    {
	    (*nonleaf)++;
	    *indxrcd += blk->count;
	    rcdptr = (unsigned char *)
	       blk + bthdr->blkhdr;
	    while (rcdnum < blk->count)
	       {
	       p = (unsigned char *)
		  rcdptr + bthdr->rcdhdr + bthdr->dletofst;
	       if (*p == DELETED)
		  (*deletes)++;
	       else
		  (*active)++;
	       rcdptr = (unsigned char *)
		  rcdptr + bthdr->rcdnode;
	       rcdnum++;
	       } /* examine delete byte */
	    } /* if index node */
	 else
	    {
	    (*leaf)++;
	    *leafrcd += blk->count;
	    } /* else leaf node */
	 } /* if good read */
      else if (!rdlen)
	 {
	 eofsw = 1;
         break;
	 } /* eof */
      else
	 {
         fprintf(stderr,"btdlets: read error\n");
         fprintf(stderr,"bthdr->blksz %d "
	    "rdlen %d\n",
	    bthdr->blksz, rdlen);
         bthdr->reason = BTREE_ERR + 2501;
         return;
	 } /* read err */
      } /* for each block in db */
   } /* btdlets */
